#include <bits/stdc++.h>

using namespace std;

#ifdef EVAL
ifstream input("input.txt");
ofstream output("output.txt");
#else
istream &input(cin);
ostream &output(cout);
#endif

int N, E;
vector<vector<int> > adj;

vector<int> find_cycle(const int without) {
    vector<bool> I(N, false), O(N, false);

    if (0 <= without)
        I[without] = O[without] = true;

    for (int s = 0; s < N; ++s) {
        vector<int> st{s};
        vector<int> cycle;

        while (not st.empty()) {
            const int u = st.back();

            if (I[u] and O[u]) {
                st.pop_back();
                continue;
            }

            if (I[u]) {
                O[u] = true;
                cycle.pop_back();
                st.pop_back();
                continue;
            }

            I[u] = true;
            cycle.emplace_back(u);
            for (const int v: adj[u]) {
                if (O[v]) continue;
                if (I[v]) return {find(cycle.begin(), cycle.end(), v), cycle.end()};

                st.emplace_back(v);
            }
        }
    }

    return {};
}

void print_cycle(const vector<int> &cycle) {
    output << cycle.size() << endl;
    for (const int u: cycle) output << u << ' ';
    output << endl;
}

int main() {
    input >> N >> E;

    adj.assign(N, vector<int>());
    for (int i = 0; i < E; i++) {
        int x, y;
        input >> x >> y;
        adj[x].emplace_back(y);
    }

    const vector<int> candidates = find_cycle(-1);
    for (const int candidate: candidates) {
        if (find_cycle(candidate).empty()) {

            output << candidate << endl;
            print_cycle(candidates);

            return 0;
        }
    }

    const vector<int> &A = candidates;
    const vector<int> B = find_cycle(A.front());

    output << -1 << endl;

    output << A.front() << endl;
    print_cycle(A);
    print_cycle(B);

    return 0;
}
